//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C167DC903BC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C167DC903BC.cm

//## begin module%3C167DC903BC.cp preserve=no
//## end module%3C167DC903BC.cp

//## Module: LevMarq%3C167DC903BC; Package specification
//## Subsystem: XSFit::FitMethod::LevMarq%3C167E2D012D
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/FitMethod/LevMarq/LevMarq.h

#ifndef LEVMARQ_H
#define LEVMARQ_H 1

//## begin module%3C167DC903BC.additionalIncludes preserve=no
//## end module%3C167DC903BC.additionalIncludes

//## begin module%3C167DC903BC.includes preserve=yes
#include <XSModel/Parameter/ModParam.h>
//## end module%3C167DC903BC.includes

// FitMethod
#include <XSFit/Fit/FitMethod.h>
//## begin module%3C167DC903BC.declarations preserve=no
//## end module%3C167DC903BC.declarations

//## begin module%3C167DC903BC.additionalDeclarations preserve=yes
extern "C" 
{

        void crfitx_ (int& nvpar, double* parval, int* parnum, double*  alpha, double* beta, 
                       double* array, double& dlamda, double* wvec, double* vmat, double*  savpar, 
                       double* ainv, double& ftstat, int& ier, int& ier2);
 
        void ivermt_(const int& ivar, double* parval, int* parnum, 
                       double* array, double* alpha, double* wvec, double* vmat,double* ainv);       
}
//## end module%3C167DC903BC.additionalDeclarations


//## begin LevMarq%3B7AE19401A3.preface preserve=yes
//## end LevMarq%3B7AE19401A3.preface

//## Class: LevMarq%3B7AE19401A3
//## Category: XSFit::FitMethod%3FC51D4803E3
//## Subsystem: XSFit::FitMethod::LevMarq%3C167E2D012D
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class LevMarq : public FitMethod  //## Inherits: <unnamed>%3B7AE241020E
{
  //## begin LevMarq%3B7AE19401A3.initialDeclarations preserve=yes
  //## end LevMarq%3B7AE19401A3.initialDeclarations

  public:
    //## Constructors (generated)
      LevMarq(const LevMarq &right);

    //## Constructors (specified)
      //## Operation: LevMarq%3C190A52016D
      LevMarq (const std::string& initString = std::string());


    //## Other Operations (specified)
      //## Operation: clone%3C84DCAA03C9
      virtual LevMarq* clone () const;

      //## Operation: reportProgress%3C8E31A1018B
      virtual void reportProgress (std::ostream& s, Fit* fit) const;

      //## Operation: settingString%3F3CE5E30395
      virtual string settingString () const;

      //## Operation: fullName%3FCE0D020040
      virtual string fullName () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: dLambda%3C8E30C80366
      //	dLambda is the constant used in Levenberg-Marquadt to
      //	bind its two
      //	modes (inverse Hessian / steepest descent).
      const Real dLambda () const;

    // Additional Public Declarations
      //## begin LevMarq%3B7AE19401A3.public preserve=yes
      //## end LevMarq%3B7AE19401A3.public

  protected:
    // Additional Protected Declarations
      //## begin LevMarq%3B7AE19401A3.protected preserve=yes
      //## end LevMarq%3B7AE19401A3.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3C84DCC601AB
      virtual void copy (const FitMethod& right);

      //## Operation: swap%3C84F12E0278
      virtual void swap (FitMethod& right);

      //## Operation: curFitXspec%468D14300056
      void curFitXspec (int* iError, int* iErrorPar);

      //## Operation: calcNewPars%468D15440056
      void calcNewPars (RealArray& newVals, const RealArray& savedVals, int* iError, int* iErrorPar);

      //## Operation: invertCorrelationMatrix%468D170203CB
      void invertCorrelationMatrix ();

      //## Operation: calcStatAndDerivatives%468D20A80318
      void calcStatAndDerivatives (const RealArray& parValues, bool doDerivatives, int* iError, int* iErrorPar);

      //## Operation: reportEigenvectors%46925078005C
      void reportEigenvectors () const;

    // Additional Private Declarations
      //## begin LevMarq%3B7AE19401A3.private preserve=yes
      //## end LevMarq%3B7AE19401A3.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: doPerform%3C5FEFDB00BB
      virtual void doPerform (Fit* fit);

    // Data Members for Class Attributes

      //## begin LevMarq::dLambda%3C8E30C80366.attr preserve=yes  public: Real {U} 0.001
      // required to be double by fortran algorithm.
      double m_dLambda;
      //## end LevMarq::dLambda%3C8E30C80366.attr

      //## Attribute: variableParameters%468D1362015F
      //	This is a subset of the Fit m_variableParameters map.
      //	It does not include any parameters belonging to
      //	components with zero norms, or pegged parameters.
      //## begin LevMarq::variableParameters%468D1362015F.attr preserve=no  private: std::map<int,ModParam*> {U} 
      std::map<int,ModParam*> m_variableParameters;
      //## end LevMarq::variableParameters%468D1362015F.attr

      //## Attribute: fitStatistic%468D141100A9
      //## begin LevMarq::fitStatistic%468D141100A9.attr preserve=no  private: Real {U} 
      Real m_fitStatistic;
      //## end LevMarq::fitStatistic%468D141100A9.attr

      //## Attribute: alpha%468D186F0002
      //## begin LevMarq::alpha%468D186F0002.attr preserve=no  private: RealArray {U} 
      RealArray m_alpha;
      //## end LevMarq::alpha%468D186F0002.attr

      //## Attribute: beta%468D1890033C
      //## begin LevMarq::beta%468D1890033C.attr preserve=no  private: RealArray {U} 
      RealArray m_beta;
      //## end LevMarq::beta%468D1890033C.attr

    // Additional Implementation Declarations
      //## begin LevMarq%3B7AE19401A3.implementation preserve=yes
      //## end LevMarq%3B7AE19401A3.implementation

};

//## begin LevMarq%3B7AE19401A3.postscript preserve=yes
//## end LevMarq%3B7AE19401A3.postscript

// Class LevMarq 

//## Get and Set Operations for Class Attributes (inline)

inline const Real LevMarq::dLambda () const
{
  //## begin LevMarq::dLambda%3C8E30C80366.get preserve=no
  return m_dLambda;
  //## end LevMarq::dLambda%3C8E30C80366.get
}

//## begin module%3C167DC903BC.epilog preserve=yes
//## end module%3C167DC903BC.epilog


#endif
